include:
  - template: SAST.gitlab-ci.yml
variables:
  SAST_ANALYZER_IMAGE_PREFIX: "registry.gitlab.com/gitlab-org/security-products/analyzers"
  SAST_DEFAULT_ANALYZERS: "nodejs-scan,secrets,eslint"
  SAST_ANALYZER_IMAGE_TAG: 2
  SAST_DISABLE_DIND: "false"
  SCAN_KUBERNETES_MANIFESTS: "false"

image: docker:19.03.1
services: 
  - docker:19.03.1-dind
stages:
  - sonar
  - build
  - sast
  - test
  - generate_image
  - deploy
analisis codigo estatico:
    stage: sonar
    image:
      name: sonarsource/sonar-scanner-cli:latest
      entrypoint: [""]
    cache:
      key: "${CI_JOB_NAME}"
      paths:
        - .sonar/cache
    script:
      - sonar-scanner
    only:
      - merge_requests
      - master
      - develop


install_dependencies:
    stage: build
    image: node:12.16.1-alpine3.11
    script:
      - npm install
    artifacts:
      paths:
        - node_modules/

spotbugs-sast:
  script:
    - /analyzer run -compile=false
  artifacts:
    reports:
      sast: gl-sast-report.json

testing_testing:
    stage: test
    image: node:12.16.1-alpine3.11
    script: ls -ltr && npm test
    artifacts:
      paths:
        - coverage/
    coverage: 
      '/All files\s*\|\s*([\d\.]+)/'

construir imagen docker:
  stage: generate_image
  #image: docker:19.03.1
  script:
    - echo "docker login -u ${USERAWS} -p ${PASSAWS} ${REGISTRY}"
    - docker login -u ${USERAWS} -p ${PASSAWS} ${REGISTRY} 
    - docker build -t $CI_PROJECT_NAME .
    - echo "docker tag $CI_PROJECT_NAME ${REGISTRY}/${CI_PROJECT_NAME}:${CI_COMMIT_SHORT_SHA}"
    - docker tag $CI_PROJECT_NAME ${REGISTRY}/${CI_PROJECT_NAME}:${CI_COMMIT_SHORT_SHA}
    - echo "docker push ${REGISTRY}/$CI_PROJECT_NAME:${CI_COMMIT_SHORT_SHA}"
    - docker push ${REGISTRY}/$CI_PROJECT_NAME:${CI_COMMIT_SHORT_SHA}


desplegar en k8:
  stage: deploy
  image: python:3.8.2-alpine3.11
  script:
    - apk --update add alpine-sdk
    - apk --update add python py-pip openssl ca-certificates py-openssl wget bash linux-headers openssl-dev libffi-dev
    - pip install awscli
    - mkdir -p ~/.aws
    - cat credentials > ~/.aws/credentials 
    - curl -LO https://storage.googleapis.com/kubernetes-release/release/v1.15.1/bin/linux/amd64/kubectl
    - chmod u+x kubectl && mv kubectl /bin/kubectl
    - export AWS_DEFAULT_REGION="us-east-1"
    - echo $AWS_DEFAULT_REGION
    - aws eks list-clusters
    - aws eks --region us-east-1  update-kubeconfig --name=microservices-development
    - sed -i "s/cambiame/${CI_COMMIT_SHORT_SHA}/g" ms-nodejs.yaml
    - cat ms-nodejs.yaml
    - kubectl apply -f ms-nodejs.yaml -n ${NAMESPACE}